/**
  *  \file client/chart/deletedrawingmode.h
  *  \brief Starchart Mode: WDeleteDrawingChartMode
  *
  *  (c) 2001-2013 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_CLIENT_CHART_DELETEDRAWINGMODE_H
#define PCC_V2_CLIENT_CHART_DELETEDRAWINGMODE_H

#include "client/chart/markermode.h"

/** Chart mode for deleting a drawing. Blinks the drawing and aske the
    user for delete permission. */
class WDeleteDrawingChartMode : public WMarkerChartMode {
    int counter;
    bool phase;
 public:
    WDeleteDrawingChartMode(GDrawingContainer::iterator p);
    ~WDeleteDrawingChartMode();

    void drawCursor(GfxCanvas& can, GChartLocation& loc);
    void drawOverlays(GfxCanvas& can, GChartLocation& loc);
    bool handleEvent(const UIEvent& event, GChartLocation& loc);
};

#endif
