/**
  *  \file client/wcost.h
  *
  *  (c) 2001-2013 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_CLIENT_WCOST_H
#define PCC_V2_CLIENT_WCOST_H

#include "ui/ui.h"
#include "game/cargo.h"
#include "game/cost.h"

class GCargoCostTransaction;
class GPlanet;
class UIAbstractTableWriter;

class WItemCostDisplay : public UIWidget {
 private:
    const GPlanet&          planet;
    GCost                   part_cost;
    GCost                   total_cost;
    int                     have_tech, need_tech;
    bool                    include_item_in_cost;

    void writeCost(UIAbstractTableWriter& tw, int32 need, int32 remain, int32 item);
 public:
    WItemCostDisplay(const GPlanet& planet, bool include_item_in_cost);
    ~WItemCostDisplay();

    void getLayoutInfo(LayoutInfo& li);
    bool handleEvent(const UIEvent& e, bool second_pass);
    void drawContent(GfxCanvas& can);

    void setPartCost(const GCost&);
    void setPartTech(int have, int need);
    void setTotalCost(const GCost&);
};

class WObservingItemCostDisplay : public WItemCostDisplay {
    SignalConnection conn_cost_change;
    GCargoCostTransaction& action;
    void onCostChange();
 public:
    WObservingItemCostDisplay(GCargoCostTransaction& action,
                     const GPlanet& planet,
                     bool include_item_in_cost);
    ~WObservingItemCostDisplay();
};

#endif
