/**
  *  \file client/widgets/objlist.h
  *
  *  (c) 2001-2013 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_CLIENT_WIDGETS_OBJLIST_H
#define PCC_V2_CLIENT_WIDGETS_OBJLIST_H

#include "ui/listbox.h"
#include "game/objlist.h"
#include "cpluslib/string.h"

class WObjectList : public UIListbox {
 public:
    WObjectList(int id, int lines, int width, GObjectList& list);
    ~WObjectList();

    // UIListBox:
    void             drawPart(GfxCanvas& can, int from, int to);
    bool             isAccessible(int index);

    // WObjectList:
    bool             selectObject(GObjectReference select);
    void             handleListChange(GObjectReference select);
    GObjectReference getCurrentObject() const;

    // Convenience Interface:
    GObjectReference doStandardDialog2(string_t title, string_t help_id);

 protected:
    // Derived Class Interface:
    void             setInfoSpace(int space);
    virtual string_t getInfoForObject(GObjectReference ref);

 private:
    GObjectList& list;
    int info_space;

    SignalConnection conn_turn_change;
    SignalConnection conn_universe_change;

    void onTurnChange();
    void onUniverseChange();
};

#endif
